// #autoload
// #name = KillCapCounter
// #description = Small hud that shows your amount of kills and caps.
// #version = 1.4
// #date = 13 January 2003
// #author = Danny de Groot
// #warrior = OddBall-
// #email = dannydg1985@hotmail.com
// #web = http://www.oddballsplace.tk
// #credit = Kaiten
// #include = support/player_support.cs
// #include = support/team_tracker.cs

new GuiControlProfile ("KillCapHudLabelProfile")
{
	fontType = "Verdana";
	fontSize = 16;
	justify = "center";
};	

new GuiControlProfile ("KillCapCountProfile")
{
	fontType = "Verdana";
	fontSize = 16;
	justify = "center";
};

package KillCapCounter {

	function KillCapCounterSetup() {

		new ShellFieldCtrl(KillCapCounter) {
			profile = "GuiConsoleProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "490 46";
			extent = "57 28";
			minExtent = "57 28";
			visible = "1";
			setFirstResponder = "0";

			new GuiTextCtrl(KillCounterLabel) {
				profile = "KillCapHudLabelProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "30 15";
				minExtent = "30 15";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new GuiTextCtrl(KillCounterText) {
				profile = "KillCapCountProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "32 0";
				extent = "25 15";
				minExtent = "25 15";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "3";
			};
			new GuiTextCtrl(CapCounterLabel) {
				profile = "KillCapHudLabelProfile";
				horizSizing = "right";
				vertSizing = "top";
				position = "0 12";
				extent = "35 16";
				minExtent = "35 16";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new GuiTextCtrl(CapCounterText) {
				profile = "KillCapCountProfile";
				horizSizing = "right";
				vertSizing = "top";
				position = "32 12";
				extent = "25 15";
				minExtent = "25 15";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "2";
			};

		};

		PlayGui.add(KillCapCounter);

	}

	function KillCountplusOne(%msgType, %msgString, %victimName, %vgen, %vposs, %killerName, %kgen, %kposs, %damageType) {
		%killer = detag(%killerName);
		%victim = detag(%victimName);

		if(%killer $= "" || %victim $= "")
			return;

		%MySelf = PlayerList.getMyName();

		if(%killer $= %MySelf && $KillCounterOn)
		{
			if(teamTracker.numTeams > 1)
			{
				%killerteamId = PlayerList.getTeamByName(%killer);
				%victimteamId = PlayerList.getTeamByName(%victim);

				if(%killerteamId == %victimteamId)
					return;
			}
			$TotalKills++;
			KillCounterText.setText($TotalKills);
		}
	}

	function CapCountplusOne(%msgType, %msgStr, %clientname, %teamName, %teamId, %capper) {
		if (!$CapCounterOn)
			return;

	        %myteamId = PlayerList.getTeamByName(PlayerList.getMyName());
		%capper = detag(%clientname);
		%flagteam = detag(%teamId);

		if(%flagteam != %myteamId && %capper $= "0")
		{
			$TotalCaps++;
			CapCounterText.setText($totalCaps);
		}
	}

	function DispatchLaunchMode() {
		KillCapCounterSetup();
		addMessageCallBack('MsgLegitKill', KillCountplusOne);
		addMessageCallBack('MsgHeadshotKill', KillCountplusOne);
		addMessageCallBack('msgExplosionKill', KillCountplusOne);
		addMessageCallBack('msgVehicleKill', KillCountplusOne);
		addMessageCallBack('msgTR2Knockdown', KillCountplusOne);
		addMessageCallBack('MsgRearshotKill', KillCountplusOne);
		addMessageCallBack('msgCTurretKill', KillCountplusOne);
		addMessageCallback('MsgCTFFlagCapped', CapCountplusOne);
		addMessageCallback('MsgClientReady', KillCapCounterRestet);

		parent::DispatchLaunchMode();
	}

	function clientCmdTogglePlayHuds(%val) {
		parent::clientCmdTogglePlayHuds(%val);
		KillCapCounter.setVisible(%val);
	}

	function PlayGui::onWake(%this) {
		if (!$KillCapCounterAddToHudmover)
		{
			if (isObject(HudMover))
				hudmover::addhud(KillCapCounter, "KillCapCounter");

			$KillCapCounterAddToHudmover = true;
		}
		parent::onWake(%this);
	}

	function ClientCmdDisplayHuds() {
		parent::ClientCmdDisplayHuds();

		switch$ ($HudMode)
		{
			case "Pilot":
				KillCapCounter.setVisible(true);

			case "Passenger":
				KillCapCounter.setVisible(true);

			case "Object":
				KillCapCounter.setVisible(false);

			case "Observer":
				KillCapCounter.setVisible(false);

			case "PickTeam":
				KillCapCounter.setVisible(false);

			default:
				KillCapCounter.setVisible(true);
		}
	}

	function KillCapCounterRestet(%msgType, %msgString, %gameType, %a2, %a3, %a4, %a5, %a6) {

		switch$ (%gameType)
		{
			case BountyGame:
				$KillCounterOn = true;
				$CapCounterOn = false;

			case CnHGame:
				$KillCounterOn = true;
				$CapCounterOn = false;

			case CTFGame:
				$KillCounterOn = true;
				$CapCounterOn = true;

			case DMGame:
				$KillCounterOn = true;
				$CapCounterOn = false;

			case DnDGame:
				$KillCounterOn = true;
				$CapCounterOn = false;

			case HuntersGame:
				$KillCounterOn = true;
				$CapCounterOn = false;

			case RabbitGame:
				$KillCounterOn = true;
				$CapCounterOn = false;

			case SiegeGame:
				$KillCounterOn = true;
				$CapCounterOn = false;

			case TeamHuntersGame:
				$KillCounterOn = true;
				$CapCounterOn = false;

			case TR2Game:
				$KillCounterOn = true;
				$CapCounterOn = false;

			case SinglePlayerGame:
				$KillCounterOn = false;
				$CapCounterOn = false;
		}

		if ($CapCounterOn)
		{
			$TotalCaps = "0";
			CapCounterLabel.setText("Caps:");
			CapCounterText.setText("0");
		}
		else
		{
			$TotalCaps = "0";
			CapCounterLabel.setText("");
			CapCounterText.setText("");	
		}

		if ($KillCounterOn)
		{
			$TotalKills = "0";
			KillCounterLabel.setText("Kills:");
			KillCounterText.setText("0");
		}
		else
		{
			$TotalKills = "0";
			KillCounterLabel.setText("");
			KillCounterText.setText("");
		}

	}

};
activatePackage(KillCapCounter);
