// #autoload
// #name = YogiTeamHud
// #version = 1.0
// #date = March 6, 2002
// #author = Yogi
// #warrior =  Yogi
// #email = yogi@tribalwar.com
// #web = http://yogi.inquisition.nu
// #category = Yogi's Scripts
// #description = Teamhud
// #status = Release
// #include = support/player_support.cs
// #include = support/stat_support.cs
// #config = YTHGuiOptions



$YTHTeamID = 0;
$YTHCellHeight = "17";
$YTHCellWidth = "125";
$YTHCells = 0;

package YogiTeamHud {

function YTHBuildTeamHud() {
//         if ($YTHTeamID == 0) return;
         %me = PlayerList.getMyName();
         %team = PlayerList.getTeamByName(%me);
         echo("I am: " @ %me);
         echo("On team: " @ %team);
         if (!isObject($YTH)) {
            YTHMakeHUD();
            echo("Making the HUD");
         }

         %lines = 0;
         %list = PlayerList.findByTeam(%team);
//         %y = getword($pref::Video::resolution, 1);
//         %x = getword($pref::Video::resolution, 0);
//         %currcell = 1;
         %count = 0;
         while (%p = getword(%list, %count)) {
               %players[%count] = %p.name;
               %count++;
               if (%count > 40) break;
         }
         %players = YTHSort(%players, %count);
         YTHClearCells();
         %id = PlayerList.getIDByName(%me);
         %deaths = StatSupport.getClientDeaths(%id);
	     %kills = StatSupport.getClientKills(%id);

         YTH.YTHCells[0].setValue("1. " @ %me @ " " @ %kills @ "-" @ %deaths);
         %cells = 1;
         for (%x=0; %x < %count; %x++) {
             if (%players[%x] !$= %me) {
                  %id = PlayerList.getIDByName(%players[%x]);
                  %deaths = StatSupport.getClientDeaths(%id);
	              %kills = StatSupport.getClientKills(%id);
                  YTH.YTHCells[%cells].setValue(%cells+1 @ ". " @ %players[%x] @ " " @ %kills @ "-" @ %deaths);
                  %cells++;
             }
         }
         YTHResize(%count);
}

function YTHMakeHUD() {
          if ($YogiPref::TeamHud::Transparent == 1) {

             %profile = "GuiConsoleProfile";
          }
          else {
//               $YogiPref::TeamHud::Transparent = 1;
               %profile = "GuiChatBackProfile";
          }

   if(!isObject($YTH)) {
         $YTH = new ShellFieldCtrl(YTH) {
			profile = %profile;
			horizSizing = "right";
			vertSizing = "top";
			position = "0 0";
			extent = "600 8";
			minExtent = "8 8";
			visible = "1";
		 };
         for (%x=0; %x < 40; %x++) {
            YTHMakeNewCell(%x);
         }
         playGui.add(YTH);
   }
}


function YTHSort(%list, %size) {
         for (%i = 0; %i < %size; %i++) {
             %min = %i;

             for (%j = %i + 1; %j < %size; %j++) {
                 if (stricmp(%list[%j], %list[%min]) == -1) {
                    %min = %j;
                 }
             }
             %temp = %list[%min];
             %list[%min] = %list[%i];
             %list[%i] = %temp;
         }
         return %list;
}

function YTHMakeNewCell(%cell) {
         %y = 0;
         %perRow = YTHCalculatePerRow();
         %val = %cell;
         while (%val > %perRow-1) {
            %val = %val - %perRow;
            %y++;
         }
         %y = %y * $YTHCellHeight + 2;
         %x = %val * $YTHCellWidth + 2;
         YTH.YTHCells[%cell] = new GuiTextCtrl() {
			profile = "GuiTextObjHudLeftProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = %x @ " " @ %y;
			extent = $YTHCellWidth @ " " @ $YTHCellHeight;
			visible = "1";
		};
    YTH.add(YTH.YTHCells[%cell]);
}

function YTHClearCells() {
         for (%x=0; %x < 40; %x++) {
             if (isObject(YTH.YTHCells[%x])) {
                YTH.YTHCells[%x].setValue("");
             }
         }
}


function YTHResize(%cells) {
//         %cells;
         %y = getword($pref::Video::resolution, 1);
         %x = getword($pref::Video::resolution, 0);
         %height = (YTHCalculateRows(%cells) * $YTHCellHeight) + YTHCalculateRows(%cells) * 2;
         %y = %y - %height;
         YTH.position = "0" @ " " @ %Y;
         YTH.extent = %x @ " " @ %height;

        objectiveHud.position = getWord(objectiveHud.position, 0) @ " " @ %y - getWord(objectiveHud.extent, 1);
		BackpackFrame.position = getWord(BackpackFrame.position, 0) @ " " @ %y - getWord(BackpackFrame.extent, 1);
		inventoryHud.position = getWord(inventoryHud.position, 0) @ " " @ %y - getWord(inventoryHud.extent, 1);
		if(getWord(weaponsHud.extent, 1) > 240) {
			weaponsHud.position = getWord(weaponsHud.position, 0) @ " " @ %y - getWord(weaponsHud.extent, 1);
		} else {
			weaponsHud.position = getWord(weaponsHud.position, 0) @ " " @ %y - 240;
		}
         
}

function YTHCalculateRows(%cells) {
         %perRow = YTHCalculatePerRow();
         %val = %cells;
         %y=1;
         while (%val > %perRow) {
            %val = %val - %perRow;
            %y++;
         }

//         echo("Num rows: " @ %y);
         return %y;
}

function YTHCalculatePerRow() {
         %x = getword($pref::Video::resolution, 0);
         %val = mfloor(%x / ($YTHCellWidth+2));
//         echo("Per row: " @ %val);
         return %val;
}



function YTHJoinTeam(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId) {
        if (!isObject($YTH))
           YTHMakeHUD();

         if (detag(%clientName) $= $YTHName) {
            $YTHTeamID = %teamId;
         }
         if ($YTHTeamID == %teamId) {
            YTHBuildTeamHud();
         }

         YTH.setVisible($YogiPref::TeamHud::Toggle);
         YTHBuildTeamHud();
}

function YTHLeft(%msgType, %msgStr, %client, %teamname, %clientID, %team) {
//         echo("Someone left team: " @ %team);
         YTHBuildTeamHud();
}

function YTHILeft(%msgtype, %msgstr, %client, %teamname, %clientid, %teamID) {
//         $YTHTeamID = %teamID;
         YTHBuildTeamHud();
         echo("I changed teams");
}


function DispatchLaunchMode() {
          parent::DispatchLaunchMode();
          addMessageCallback('MsgClientJoin', YTHBuildTeamHud);
          addMessageCallback('MsgClientJoinTeam', YTHBuildTeamHud); //YTHJoinTeam);
          addMessageCallback('msgLeftTeam', YTHBuildTeamHud);
          addMessageCallback('MsgClientDrop', YTHBuildTeamHud);
          addMessageCallback('msgITeamChanged', YTHBuildTeamHud);
          addMessageCallback( 'MsgForceObserver', YTHBuildTeamHud);
          
          addMessageCallBack('MsgLegitKill', YTHBuildTeamHud);
          addMessageCallBack('msgSuicide', YTHBuildTeamHud);
          addMessageCallBack('msgVehicleKill', YTHBuildTeamHud);
          addMessageCallBack('msgCTurretKill', YTHBuildTeamHud);
          addMessageCallBack('msgSelfKill', YTHBuildTeamHud);
          addMessageCallBack('MsgHeadshotKill', YTHBuildTeamHud);
          addMessageCallBack('msgExplosionKill', YTHBuildTeamHud);
          addMessageCallBack('msgVehicleSpawnKill', YTHBuildTeamHud);
          addMessageCallBack('msgVehicleCrash', YTHBuildTeamHud);
          addMessageCallBack('msgTurretKill', YTHBuildTeamHud);
          addMessageCallBack('msgOOBKill', YTHBuildTeamHud);
          addMessageCallBack('msgCampKill', YTHBuildTeamHud);
          addMessageCallBack('msgTeamKill', YTHBuildTeamHud);
          addMessageCallBack('msgLavaKill', YTHBuildTeamHud);
          addMessageCallBack('msgLightningKill', YTHBuildTeamHud);
          addMessageCallBack('MsgRogueMineKill', YTHBuildTeamHud);

}

function quit() {
		// If not saved already (can be done from another script)
		if(!$YogiPrefsSaved)
		{
			// Save the prefs to a file
			export("$YogiPref::*", "prefs/YogiPrefs.cs", false);
			// Set the pref that says so
			$YogiPrefsSaved = true;
		}

		parent::quit();
}


function YTHTransparent::onAction(%this) {

          if (%this.getValue()) {
//             $YogiPref::TeamHud::Transparent = 1;
             YTH.setProfile("GuiConsoleProfile");
          }
          else {
//               $YogiPref::TeamHud::Transparent = 1;
               YTH.setProfile("GuiChatBackProfile");
          }
}

function YTHToggle(%val) {
         if (!%val) return;
         if ($YogiPref::TeamHud::Toggle) {
            YTH.setVisible(false);
            $YogiPref::TeamHud::Toggle = false;
         }
         else {
            YTH.setVisible(true);
            $YogiPref::TeamHud::Toggle = true;
         }
//         echo("I toggled");
}

function OptionsDlg::onWake( %this ) {
         if (!$YogiTeamHudMap) {
            $RemapName[$RemapCount]="Toggle Yogi Teamhud";
            $RemapCmd[$RemapCount]="YTHToggle";
            $RemapCount++;
            $YogiTeamHudMap = true;
         }
         parent::onWake( %this );
}


};

if(isFile("prefs/YogiPrefs.cs") && !$YogiPrefsLoaded) {
		exec("prefs/YogiPrefs.cs");
		$YogiPrefsLoaded = true;
}

new GuiControl(YTHGuiOptions) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
        position = "157 80";
		extent = "350 150";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Yogi TeamHud Options";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellToggleButton(YTHTransparent) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "95 62";
			extent = "140 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
            variable = "$YogiPref::TeamHud::Transparent";
			helpTag = "0";
			text = "Transparent Hud";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "-1";
		};
	};
};


activatePackage(YogiTeamHud);
